package it.polimi.deib.ingsw.multithreading.ese1;

public class EsempioThread {
	public static void main(String args[]) {
		Contatore contatore = new Contatore();
		Thread t1 = new Thread1(contatore);
		Thread t2 = new Thread2(contatore);
    t1.start();
		t2.start();
		try {
			t1.join();
			t2.join();
		} catch(InterruptedException e) { e.printStackTrace(); }
		System.out.println("Fatto!");
	}

}

class Contatore {
  private int contatore = 0;
  
  public synchronized void incrementa() {
    contatore++;
  }
  
  public synchronized void decrementa() {
    contatore--;
  }
  
  public synchronized int getContatore() {
    return contatore;
  }
}


class Thread1 extends Thread {
	private final Contatore c;
	
	public Thread1(Contatore c) {
		this.c = c;
	}
	
	public void run() {
		for (int i=0; i<10; i++) {
			c.incrementa();
			System.out.println("inc: " + c.getContatore());
		}
	}
}

class Thread2 extends Thread {
	private final Contatore c;
	
	public Thread2(Contatore c) {
		this.c = c;
	}
	
	public void run() {
		for (int i=0; i<10; i++) {
			c.decrementa();
			System.out.println("dec: " + c.getContatore());
		}
	}
}