package it.polimi.deib.ingsw.multithreading.ese3;

import java.util.LinkedList;
import java.util.Queue;
import java.util.Random;


public class Centralino {
	private int centralinistiDisponibili = 5;
	
	private Queue<Cliente> clientiInAttesa = new LinkedList<Cliente>();  
	
	public void chiama(Cliente cliente) {
		
		System.out.println("Ricevuta chiamata da " +  cliente.getNome());
		accettaChiamata(cliente);
		System.out.println("Accettata chiamata da " +  cliente.getNome());
		
		Random random = new Random();
		try {
			Thread.sleep(4000 + random.nextInt(2000));
		} catch (InterruptedException e) {
		}
		
		chiudiChiamata(cliente);
		
	}
	
	private void accettaChiamata(Cliente cliente) {
		synchronized (clientiInAttesa) {
			if (centralinistiDisponibili<=0) {
				clientiInAttesa.offer(cliente);
				do {
					try {
						clientiInAttesa.wait();
					} catch (InterruptedException e) {
					}
				} while (centralinistiDisponibili<=0 || cliente != clientiInAttesa.peek());
			  System.out.println("POLLED " + cliente.getNome());
				clientiInAttesa.poll();
			}
			centralinistiDisponibili--;
		}
	}
	
	private void chiudiChiamata(Cliente cliente) {
		synchronized (clientiInAttesa) {
			centralinistiDisponibili++;
			clientiInAttesa.notifyAll();
		}
	}
}
